Freeciv-3.1: /fast/freeciv/nightly/S3_1/common/effects.c File Reference

Freeciv-3.1

Loading...
Searching...
No Matches
Functions | Variables
effects.c File Reference
`#include <ctype.h>`
`#include <string.h>`
`#include "astring.h"`
`#include "fcintl.h"`
`#include "log.h"`
`#include "mem.h"`
`#include "support.h"`
`#include "shared.h"`
`#include "string_vector.h"`
`#include "city.h"`
`#include "game.h"`
`#include "government.h"`
`#include "improvement.h"`
`#include "map.h"`
`#include "packets.h"`
`#include "player.h"`
`#include "tech.h"`
`#include "effects.h"`

Go to the source code of this file.

## Functions

struct effect_list * | get_effects (enum effect_type effect_type)
struct effect_list * | get_req_source_effects (struct universal *psource)
struct effect * | effect_new (enum effect_type type, int value, struct multiplier *pmul)
void | effect_remove (struct effect *peffect)
struct effect * | effect_copy (struct effect *old)
void | effect_req_append (struct effect *peffect, struct requirement req)
void | ruleset_cache_init (void)
void | ruleset_cache_free (void)
int | effect_cumulative_max (enum effect_type type, struct universal *unis, size_t n_unis)
int | effect_cumulative_min (enum effect_type type, struct universal *for_uni)
int | effect_value_from_universals (enum effect_type type, struct universal *unis, size_t n_unis)
bool | effect_universals_value_never_below (enum effect_type type, struct universal *unis, size_t n_unis, int min_value)
int | effect_value_will_make_positive (enum effect_type type)
void | recv_ruleset_effect (const struct packet_ruleset_effect *packet)
void | send_ruleset_cache (struct conn_list *dest)
bool | building_has_effect (const struct impr_type *pimprove, enum effect_type effect_type)
static bool | is_effect_prevented (const struct req_context *context, const struct player *other_player, const struct effect *peffect, const enum req_problem_type prob_type)
bool | is_building_replaced (const struct city *pcity, const struct impr_type *pimprove, const enum req_problem_type prob_type)
int | get_target_bonus_effects (struct effect_list *plist, const struct req_context *context, const struct player *other_player, enum effect_type effect_type)
double | get_effect_expected_value (const struct req_context *context, const struct player *other_player, enum effect_type effect_type, eft_value_filter_cb weighter, void *data, int n_data)
int | get_world_bonus (enum effect_type effect_type)
int | get_player_bonus (const struct player *pplayer, enum effect_type effect_type)
int | get_city_bonus (const struct city *pcity, enum effect_type effect_type)
int | get_city_specialist_output_bonus (const struct city *pcity, const struct specialist *pspecialist, const struct output_type *poutput, enum effect_type effect_type)
int | get_city_tile_output_bonus (const struct city *pcity, const struct tile *ptile, const struct output_type *poutput, enum effect_type effect_type)
int | get_tile_output_bonus (const struct city *pcity, const struct tile *ptile, const struct output_type *poutput, enum effect_type effect_type)
int | get_player_output_bonus (const struct player *pplayer, const struct output_type *poutput, enum effect_type effect_type)
int | get_city_output_bonus (const struct city *pcity, const struct output_type *poutput, enum effect_type effect_type)
int | get_building_bonus (const struct city *pcity, const struct impr_type *building, enum effect_type effect_type)
int | get_unittype_bonus (const struct player *pplayer, const struct tile *ptile, const struct unit_type *punittype, const struct action *paction, enum effect_type effect_type)
int | get_unit_bonus (const struct unit *punit, enum effect_type effect_type)
int | get_unit_vs_tile_bonus (const struct tile *ptile, const struct unit *punit, enum effect_type etype)
int | get_player_bonus_effects (struct effect_list *plist, const struct player *pplayer, enum effect_type effect_type)
int | get_city_bonus_effects (struct effect_list *plist, const struct city *pcity, const struct output_type *poutput, enum effect_type effect_type)
int | get_current_construction_bonus (const struct city *pcity, enum effect_type effect_type, const enum req_problem_type prob_type)
int | get_potential_improvement_bonus (const struct impr_type *pimprove, const struct city *pcity, enum effect_type effect_type, const enum req_problem_type prob_type, bool consider_multipliers)
void | get_effect_req_text (const struct effect *peffect, char *buf, size_t buf_len)
void | get_effect_list_req_text (const struct effect_list *plist, struct astring *astr)
bool | iterate_effect_cache (iec_cb cb, void *data)

## Variables

static bool | initialized = FALSE
struct { |
struct effect_list * tracker |
struct effect_list * effects [EFT_COUNT] |
struct { |
struct effect_list * buildings [B_LAST] |
struct effect_list * govs [G_LAST] |
struct effect_list * advances [A_LAST] |
} reqs |
} | ruleset_cache |

## Function Documentation

## ◆ building_has_effect()

bool building_has_effect | ( | const struct impr_type * | pimprove,
|  | enum effect_type effect_type effect_type |
| ) |  |

Returns TRUE if the building has any effect bonuses of the given type.

Note that this function returns a boolean rather than an integer value giving the exact bonus. Finding the exact bonus requires knowing the effect range and may take longer. This function should only be used in situations where the range doesn't matter.

Definition at line 587 of file effects.c.

Referenced by building_crucial(), can_player_build_improvement_direct(), get_building_for_effect(), helptext_building(), try_to_sell_stuff(), and valid_improvement().

## ◆ effect_copy()

struct effect * effect_copy | ( | struct effect * | old | ) |

Return new copy of the effect

Definition at line 214 of file effects.c.

Referenced by effect_handle_split_universal().

## ◆ effect_cumulative_max()

int effect_cumulative_max | ( | enum effect_type | type,
|  | struct universal * | unis,
|  | size_t | n_unis
| ) |  |

Get the maximum effect value in this ruleset for the universal (that is, the sum of all positive effects clauses that apply specifically to this universal – this can be an overestimate in the case of mutually exclusive effects). for_uni can be NULL to get max effect value ignoring requirements.

Definition at line 331 of file effects.c.

Referenced by helptext_unit(), rs_common_units(), rs_max_city_radius_sq(), sanity_check_boolean_effects(), set_unit_type_caches(), and utype_unknown_move_cost().

## ◆ effect_cumulative_min()

int effect_cumulative_min | ( | enum effect_type | type,
|  | struct universal * | for_uni
| ) |  |

Get the minimum effect value in this ruleset for the universal (that is, the sum of all negative effects clauses that apply specifically to this universal – this can be an overestimate in the case of mutually exclusive effects). for_uni can be NULL to get min effect value ignoring requirements.

Definition at line 367 of file effects.c.

Referenced by effect_value_will_make_positive(), and sanity_check_boolean_effects().

## ◆ effect_new()

struct effect * effect_new | ( | enum effect_type | type,
|  | int | value,
|  | struct multiplier * | pmul
| ) |  |

Add effect to ruleset cache.

Definition at line 179 of file effects.c.

Referenced by effect_edit::add_now(), effect_copy(), load_ruleset_effects(), paratroopers_mr_sub_to_effect(), recv_ruleset_effect(), rscompat_postprocess(), and slow_invasion_effects().

## ◆ effect_remove()

void effect_remove | ( | struct effect * | peffect | ) |

Remove effect from the caches.

Definition at line 205 of file effects.c.

Referenced by effect_edit::delete_now().

## ◆ effect_req_append()

void effect_req_append | ( | struct effect * | peffect,
|  | struct requirement | req
| ) |  |

Append requirement to effect.

Definition at line 229 of file effects.c.

Referenced by effect_edit::add_now(), effect_copy(), effect_list_compat_cb(), load_ruleset_effects(), paratroopers_mr_sub_to_effect(), recv_ruleset_effect(), rscompat_postprocess(), and slow_invasion_effects().

## ◆ effect_universals_value_never_below()

bool effect_universals_value_never_below | ( | enum effect_type | type,
|  | struct universal * | unis,
|  | size_t | n_unis,
|  | int | min_value
| ) |  |

Returns TRUE iff the specified effect type is guaranteed to always have a value at or above the specified value given the presence of the specified list of universals. Note that it may be true that the effect type always will be at or above the specified value a even if this function refuses to guarantee it by returning FALSE. It may simply be unable to detect that it is so.

Parameters

  type | the effect type
  unis | the list of present universals
  n_unis | the number of universals in unis
  min_value | the value the effect always should be at or above

Returns
  TRUE iff the function promises that the value of the effect type never will be below min_value given the specified universals.

Definition at line 488 of file effects.c.

Referenced by helptext_unit(), utype_act_takes_all_mp_cache_set(), and utype_act_takes_all_mp_ustate_cache_set().

## ◆ effect_value_from_universals()

int effect_value_from_universals | ( | enum effect_type | type,
|  | struct universal * | unis,
|  | size_t | n_unis
| ) |  |

Return the base value of a given effect that can always be expected from just the sources in the list, independent of other factors. Adds up all the effects that rely only on these universals; effects that have extra conditions are ignored. In effect, 'unis' is a template against which effects are matched. The first universal in the list is special: effects must have a condition that specifically applies to that source to be included (may be a superset requirement, e.g. ExtraFlag for VUT_EXTRA source).

Definition at line 402 of file effects.c.

Referenced by extra_bonus_for_terrain(), and helptext_unit().

## ◆ effect_value_will_make_positive()

int effect_value_will_make_positive | ( | enum effect_type | type | ) |

Returns a value that, if found in an effect value, always will make the result of any evaluation where it is active positive.

Definition at line 525 of file effects.c.

## ◆ get_building_bonus()

int get_building_bonus | ( | const struct city * | pcity,
|  | const struct impr_type * | building,
|  | enum effect_type effect_type effect_type |
| ) |  |

Returns the effect bonus at a building.

Definition at line 930 of file effects.c.

Referenced by city_improvement_upkeep(), impr_build_shield_cost(), and impr_buy_gold_cost().

## ◆ get_city_bonus()

int get_city_bonus | ( | const struct city * | pcity,
|  | enum effect_type effect_type effect_type |
| ) |  |

Returns the effect bonus at a city.

Definition at line 789 of file effects.c.

Referenced by api_effects_city_bonus(), citizen_content_buildings(), citizen_happiness_nationality(), citizen_happy_wonders(), city_airlift_max(), city_build_slots(), city_can_grow_to(), city_citywalls_gfx(), city_culture(), city_dialog_update_supported_units(), city_got_defense_effect(), city_granary_savings(), city_history_gain(), city_incite_cost(), city_map_update_radius_sq(), city_migration_score(), city_pollution_types(), city_rapture_grow(), city_refresh_vision(), city_support(), city_turn_notify(), city_unit_slots_available(), city_unit_unhappiness(), create_unit_surface(), dai_action_choose_sub_tgt_unit_vs_city(), dai_assess_military_unhappiness(), dai_content_effect_value(), dai_effect_value(), dai_set_defenders(), dai_spend_gold(), dai_war_desire(), diplomat_sabotage(), do_attack(), get_city_dialog_output_text(), get_city_health(), get_city_sprite(), get_city_tithes_bonus(), is_gov_center(), max_trade_routes(), military_advisor_choose_build(), multiairlift(), package_city(), redraw_city_dialog(), redraw_unit_info_label(), set_city_production(), spy_steal_gold(), text_happiness_nationality(), text_happiness_units(), unit_bombard(), update_capital(), update_city_activity(), update_dumb_city(), and city_dialog::update_units().

## ◆ get_city_bonus_effects()

int get_city_bonus_effects | ( | struct effect_list * | plist,
|  | const struct city * | pcity,
|  | const struct output_type * | poutput,
|  | enum effect_type effect_type effect_type |
| ) |  |

Returns the effect sources of this type currently active at the city.

The returned vector must be freed (building_vector_free) when the caller is done with it.

Definition at line 1075 of file effects.c.

Referenced by get_city_dialog_culture_text(), get_city_dialog_illness_text(), get_city_dialog_output_text(), redraw_happiness_city_dialog(), text_happiness_buildings(), and text_happiness_wonders().

## ◆ get_city_output_bonus()

int get_city_output_bonus | ( | const struct city * | pcity,
|  | const struct output_type * | poutput,
|  | enum effect_type effect_type effect_type |
| ) |  |

Returns the player effect bonus of an output.

Definition at line 906 of file effects.c.

Referenced by city_units_upkeep(), and city_waste().

## ◆ get_city_specialist_output_bonus()

int get_city_specialist_output_bonus | ( | const struct city * | pcity,
|  | const struct specialist * | pspecialist,
|  | const struct output_type * | poutput,
|  | enum effect_type effect_type effect_type |
| ) |  |

Returns the effect bonus of a specialist in a city.

Definition at line 807 of file effects.c.

Referenced by get_specialist_output().

## ◆ get_city_tile_output_bonus()

int get_city_tile_output_bonus | ( | const struct city * | pcity,
|  | const struct tile * | ptile,
|  | const struct output_type * | poutput,
|  | enum effect_type effect_type effect_type |
| ) |  |

Returns the effect bonus at a city tile. pcity must be supplied.

FIXME: this is now used both for tile bonuses, tile-output bonuses, and city-output bonuses. Thus ptile or poutput may be NULL for certain callers. This could be changed by adding 2 new functions to the interface but they'd be almost identical and their likely names would conflict with functions already in city.c. It's also very similar to get_tile_output_bonus(); it should be called when the city is mandatory.

Definition at line 838 of file effects.c.

Referenced by base_city_can_work_tile(), city_tc_effect_refresh(), get_final_city_output_bonus(), and tile_change_side_effects().

## ◆ get_current_construction_bonus()

int get_current_construction_bonus | ( | const struct city * | pcity,
|  | enum effect_type effect_type effect_type | ,
|  | const enum req_problem_type | prob_type
| ) |  |

Returns the effect bonus the currently-in-construction-item will provide.

Note this is not called get_current_production_bonus because that would be confused with EFT_PROD_BONUS.

Problem type tells if we need to be CERTAIN about bonus before counting it or is POSSIBLE bonus enough.

Definition at line 1104 of file effects.c.

Referenced by city_build_building(), city_increase_size(), and city_turn_notify().

## ◆ get_effect_expected_value()

double get_effect_expected_value | ( | const struct req_context * | context,
|  | const struct player * | other_player,
|  | enum effect_type effect_type effect_type | ,
|  | eft_value_filter_cb | weighter,
|  | void * | data,
|  | int | n_data
| ) |  |

Returns the expected value of the effect of given type for given context, calculating value weighted with probability for each individual effect with given callback using arbitrary additional data passed to it.

The way of using multipliers is left on the callback.

Definition at line 736 of file effects.c.

## ◆ get_effect_list_req_text()

void get_effect_list_req_text | ( | const struct effect_list * | plist,
|  | struct astring * | astr
| ) |  |

Make user-friendly text for an effect list. The text is put into a user astring.

Definition at line 1225 of file effects.c.

Referenced by do_tech_parasite_effect(), text_happiness_buildings(), and text_happiness_wonders().

## ◆ get_effect_req_text()

void get_effect_req_text | ( | const struct effect * | peffect,
|  | char * | buf,
|  | size_t | buf_len
| ) |  |

Make user-friendly text for the source. The text is put into a user buffer.

Definition at line 1197 of file effects.c.

Referenced by get_city_dialog_culture_text(), get_city_dialog_illness_text(), get_city_dialog_output_text(), and get_effect_list_req_text().

## ◆ get_effects()

struct effect_list * get_effects | ( | enum effect_type effect_type effect_type |  | ) |

Get a list of effects of this type.

Definition at line 136 of file effects.c.

Referenced by adv_units_ruleset_init(), dai_find_source_building(), effect_new(), effect_remove(), effect_universals_value_never_below(), effect_value_from_universals(), get_effect_expected_value(), get_target_bonus_effects(), is_effect_val_known(), ruleset_purge_redundant_reqs_effects(), and ruleset_purge_unused_effects().

## ◆ get_player_bonus()

int get_player_bonus | ( | const struct player * | pplayer,
|  | enum effect_type effect_type effect_type |
| ) |  |

Returns the effect bonus for a player.

Definition at line 771 of file effects.c.

Referenced by adv_best_government(), adv_gov_player_bonus_want(), api_effects_player_bonus(), can_change_to_government(), can_player_build_improvement_direct(), can_player_build_unit_direct(), check_for_game_over(), civil_war_triggered(), could_meet_with_player(), dai_assess_military_unhappiness(), dai_content_effect_value(), dai_diplomacy_actions(), dai_diplomacy_begin_new_phase(), dai_effect_value(), dai_gov_value(), dai_manage_taxes(), do_border_vision_effect(), do_have_contacts_effect(), do_reveal_effects(), do_upgrade_effects(), economy_report_dialog_popup(), fc_double_edge::fc_double_edge(), found_new_tech(), get_player_maxrate(), handle_diplomacy_cancel_pact(), handle_diplomacy_init_meeting_req(), handle_player_change_government(), horiz_taxrate_callback(), make_contact(), nation_history_gain(), player_base_citizen_happiness(), player_culture(), player_has_embassy_from_effect(), player_has_really_useful_tech_parasite(), player_tech_upkeep(), popup_rates_dialog(), pplayer_can_cancel_treaty(), pplayer_can_make_treaty(), rates_set_values(), remove_city(), research_total_bulbs_required(), split_player(), steal_a_tech(), tax_rates_dialog::tax_rates_dialog(), text_happiness_cities(), try_summon_barbarians(), unit_upgrade_price(), fc_client::update_sidebar_tooltips(), utype_happy_cost(), and utype_upkeep_cost().

## ◆ get_player_bonus_effects()

int get_player_bonus_effects | ( | struct effect_list * | plist,
|  | const struct player * | pplayer,
|  | enum effect_type effect_type effect_type |
| ) |  |

Returns the effect sources of this type currently active at the player.

The returned vector must be freed (building_vector_free) when the caller is done with it.

Definition at line 1052 of file effects.c.

Referenced by do_tech_parasite_effect().

## ◆ get_player_output_bonus()

int get_player_output_bonus | ( | const struct player * | pplayer,
|  | const struct output_type * | poutput,
|  | enum effect_type effect_type effect_type |
| ) |  |

Returns the player effect bonus of an output.

Definition at line 883 of file effects.c.

Referenced by get_tile_output_text(), and utype_upkeep_cost().

## ◆ get_potential_improvement_bonus()

int get_potential_improvement_bonus | ( | const struct impr_type * | pimprove,
|  | const struct city * | pcity,
|  | enum effect_type effect_type effect_type | ,
|  | const enum req_problem_type | prob_type,
|  | bool | consider_multipliers
| ) |  |

Returns the effect bonus the improvement would or does provide if present.

Problem type tells if we need to be CERTAIN about bonus before counting it or is POSSIBLE bonus enough.

Definition at line 1126 of file effects.c.

Referenced by get_current_construction_bonus(), improvement_has_effects(), and rs_buildings().

## ◆ get_req_source_effects()

struct effect_list * get_req_source_effects | ( | struct universal * | psource | ) |

Get a list of effects with this requirement source.

Currently only buildings, advances, and governments are supported.

Definition at line 146 of file effects.c.

Referenced by adjust_improvement_wants_by_effects(), adv_data_city_impr_calc(), building_has_effect(), dai_gov_value(), dai_tech_effect_values(), effect_req_append(), get_potential_improvement_bonus(), helptext_government(), improvement_has_effects(), and is_building_replaced().

## ◆ get_target_bonus_effects()

int get_target_bonus_effects | ( | struct effect_list * | plist,
|  | const struct req_context * | context,
|  | const struct player * | other_player,
|  | enum effect_type effect_type effect_type |
| ) |  |

Returns the effect bonus of a given type for any target.

context gives the target (or targets) to evaluate requirements against effect_type gives the effect type to be considered

context may be NULL. This is equivalent to passing an empty context.

Returns the effect sources of this type currently active.

The returned vector must be freed (building_vector_free) when the caller is done with it.

Definition at line 691 of file effects.c.

Referenced by action_dice_roll_odds(), action_success_target_pay_mp(), ap_dipl_battle_win(), api_effects_unit_bonus(), api_methods_city_inspire_partisans(), casus_belli_range_for(), city_tile_output(), dai_choose_trade_route(), defense_multiplication(), diplomat_success_vs_defender(), do_heal_unit(), fill_grid_sprite_array(), get_building_bonus(), get_caravan_enter_city_trade_bonus(), get_city_bonus(), get_city_bonus_effects(), get_city_output_bonus(), get_city_specialist_output_bonus(), get_city_tile_output_bonus(), get_player_bonus(), get_player_bonus_effects(), get_player_output_bonus(), get_tile_output_bonus(), get_unit_bonus(), get_unit_vs_tile_bonus(), get_unittype_bonus(), get_world_bonus(), helptext_government(), illegal_action_pay_price(), impr_estimate_build_shield_cost(), process_attacker_want(), sdi_try_defend(), spy_steal_some_maps(), unit_bribe_cost(), unit_pays_mp_for_action(), unit_shield_value(), and utype_pays_mp_for_action_estimate().

## ◆ get_tile_output_bonus()

int get_tile_output_bonus | ( | const struct city * | pcity,
|  | const struct tile * | ptile,
|  | const struct output_type * | poutput,
|  | enum effect_type effect_type effect_type |
| ) |  |

Returns the effect bonus at a tile for given output type (or NULL for output-type-independent bonus). If pcity is supplied, it's the bonus for that particular city, otherwise it's the player/city-independent bonus (and any city on the tile is ignored).

Definition at line 862 of file effects.c.

Referenced by city_tile_output().

## ◆ get_unit_bonus()

int get_unit_bonus | ( | const struct unit * | punit,
|  | enum effect_type effect_type effect_type |
| ) |  |

Returns the effect bonus at a unit

Definition at line 992 of file effects.c.

Referenced by begin_turn(), dai_find_strategic_airbase(), diplomats_unignored_tech_stealings(), hp_gain_coord(), is_losing_hp(), maybe_become_veteran_real(), regen_turns(), request_unit_return(), spy_steal_gold(), unit_conquer_city(), unit_gain_hitpoints(), and unit_versus_unit().

## ◆ get_unit_vs_tile_bonus()

int get_unit_vs_tile_bonus | ( | const struct tile * | ptile,
|  | const struct unit * | punit,
|  | enum effect_type | etype
| ) |  |

Returns the effect bonus at a tile

Definition at line 1016 of file effects.c.

Referenced by api_effects_unit_vs_tile_bonus().

## ◆ get_unittype_bonus()

int get_unittype_bonus | ( | const struct player * | pplayer,
|  | const struct tile * | ptile,
|  | const struct unit_type * | punittype,
|  | const struct action * | paction,
|  | enum effect_type effect_type effect_type |
| ) |  |

Returns the effect bonus that applies at a tile for a given unittype.

For instance with EFT_DEFEND_BONUS the attacker's unittype and the defending tile should be passed in. Slightly counter-intuitive! See doc/README.effects to see how the unittype applies for each effect here.

Definition at line 957 of file effects.c.

Referenced by assess_danger(), assess_danger_unit(), city_got_defense_effect(), city_production_unit_veteran_level(), dai_choose_defender_versus(), dai_wants_defender_against(), defense_multiplication(), find_nearest_safe_city(), get_modified_firepower(), get_total_attack_power(), pf_reverse_map_utype_pos(), pft_fill_utype_default_parameter(), unit_type_is_losing_hp(), unit_vision_range_modifiers(), utype_build_shield_cost(), utype_buy_gold_cost(), utype_move_rate(), and utype_pop_value().

## ◆ get_world_bonus()

int get_world_bonus | ( | enum effect_type effect_type effect_type |  | ) |

Returns the effect bonus for the whole world.

Definition at line 759 of file effects.c.

Referenced by api_effects_world_bonus(), game_next_year(), and tri_req_active_turns().

## ◆ is_building_replaced()

bool is_building_replaced | ( | const struct city * | pcity,
|  | const struct impr_type * | pimprove,
|  | const enum req_problem_type | prob_type
| ) |  |

Returns TRUE if a building is replaced. To be replaced, all its effects must be made redundant by groups that it is in. prob_type CERTAIN or POSSIBLE is answer to function name.

Definition at line 641 of file effects.c.

Referenced by is_improvement_redundant().

## ◆ is_effect_prevented()

static bool is_effect_prevented | ( | const struct req_context * | context,
|  | const struct player * | other_player,
|  | const struct effect * | peffect,
|  | const enum req_problem_type | prob_type
| ) |  |

static

Return TRUE iff any of the disabling requirements for this effect are active, which would prevent it from taking effect. (Assumes that any requirement specified in the ruleset with a negative sense is an impediment.)

context may be NULL. This is equivalent to passing an empty context.

Definition at line 618 of file effects.c.

Referenced by is_building_replaced().

## ◆ iterate_effect_cache()

bool iterate_effect_cache | ( | iec_cb | cb,
|  | void * | data
| ) |  |

Iterate through all the effects in cache, and call callback for each. If any callback returns FALSE, there is no further checking and this will return FALSE.

Definition at line 1245 of file effects.c.

Referenced by is_multiplier_needed(), is_universal_needed(), effect_edit::refresh(), tab_misc::refresh_stats(), rscompat_postprocess(), sanity_check_ruleset_data(), and save_effects_ruleset().

## ◆ recv_ruleset_effect()

void recv_ruleset_effect | ( | const struct packet_ruleset_effect * | packet | ) |

Receives a new effect. This is called by the client when the packet arrives.

Definition at line 534 of file effects.c.

Referenced by handle_ruleset_effect().

## ◆ ruleset_cache_free()

void ruleset_cache_free | ( | void |  | ) |

Free the ruleset cache. This should be called at the end of the game or when the client disconnects from the server. See ruleset_cache_init.

Definition at line 271 of file effects.c.

Referenced by game_ruleset_free().

## ◆ ruleset_cache_init()

void ruleset_cache_init | ( | void |  | ) |

Initialize the ruleset cache. The ruleset cache should be empty before this is done (so if it's previously been initialized, it needs to be freed (see ruleset_cache_free) before it can be reused).

Definition at line 245 of file effects.c.

Referenced by game_ruleset_init().

## ◆ send_ruleset_cache()

void send_ruleset_cache | ( | struct conn_list * | dest | ) |

Send the ruleset cache data over the network.

Definition at line 553 of file effects.c.

Referenced by send_rulesets().

## Variable Documentation

## ◆ advances

struct effect_list* advances[A_LAST]

Definition at line 128 of file effects.c.

## ◆ buildings

struct effect_list* buildings[B_LAST]

Definition at line 124 of file effects.c.

## ◆ effects

struct effect_list* effects[EFT_COUNT]

Definition at line 120 of file effects.c.

Referenced by do_tech_parasite_effect(), receive_packet_ruleset_disaster_100(), text_happiness_buildings(), and text_happiness_wonders().

## ◆ govs

struct effect_list* govs[G_LAST]

Definition at line 126 of file effects.c.

## ◆ initialized

bool initialized = FALSE

static

Definition at line 42 of file effects.c.

Referenced by apply_text_tag(), audio_shutdown(), get_building_bonus(), get_city_bonus(), get_city_bonus_effects(), get_city_output_bonus(), get_current_construction_bonus(), get_player_bonus(), get_player_bonus_effects(), get_player_output_bonus(), get_unit_bonus(), get_unit_vs_tile_bonus(), get_unittype_bonus(), get_world_bonus(), packet_handlers_initial(), ruleset_cache_free(), and ruleset_cache_init().

## ◆ [struct]

struct { ... } reqs

Referenced by actions_free(), actions_init(), are_reqs_active(), basic_city_style_for_style(), city_style(), city_styles_alloc(), city_styles_free(), disaster_types_init(), dlsend_packet_ruleset_multiplier(), dsend_packet_ruleset_multiplier(), effect_to_enabler(), extras_free(), extras_init(), goods_free(), goods_init(), helptext_building(), helptext_goods(), helptext_government(), helptext_specialist(), is_universal_needed(), load_ruleset_buildings(), load_ruleset_cities(), load_ruleset_effects(), load_ruleset_game(), load_ruleset_governments(), load_ruleset_styles(), load_ruleset_terrain(), mke_eval_reqs(), moves_left_range(), multipliers_init(), music_styles_alloc(), purge_duplicate_req_vec(), purge_redundant_req_vec(), purge_unused_req_vec(), receive_packet_ruleset_action_auto_100(), receive_packet_ruleset_building_100(), receive_packet_ruleset_city_100(), receive_packet_ruleset_disaster_100(), receive_packet_ruleset_effect_100(), receive_packet_ruleset_extra_100(), receive_packet_ruleset_goods_100(), receive_packet_ruleset_government_100(), receive_packet_ruleset_multiplier_100(), receive_packet_ruleset_music_100(), receive_packet_ruleset_specialist_100(), req_vec_is_impossible_to_fulfill(), req_vec_wants_type(), reqs_may_activate(), sanity_check_ruleset_data(), save_reqs_vector(), save_styles_ruleset(), send_ruleset_cities(), tri_reqs_cb_active(), universal_fulfills_requirements(), universal_is_mentioned_by_requirements(), universal_replace_in_req_vec(), universals_mean_unfulfilled(), universals_say_everything(), and unpack_tech_req().

## ◆ [struct]

struct { ... } ruleset_cache

Referenced by effect_cumulative_max(), effect_cumulative_min(), effect_new(), effect_remove(), get_effects(), get_req_source_effects(), iterate_effect_cache(), ruleset_cache_free(), ruleset_cache_init(), and send_ruleset_cache().

## ◆ tracker

struct effect_list* tracker

Definition at line 116 of file effects.c.